#include "spi_flash.h"
#include <linux/interrupt.h>
#include <asm/system.h>
#include "monitor.h"
#include "etherboot.h"
#include "nic.h"
#include <asm/rtl8196.h>
#include <asm/mipsregs.h>	//wei add

extern char _bootimg_start, _bootimg_end;


#define LENGTH(i)       SPI_LENGTH(i)
#define CS(i)           SPI_CS(i)
#define RD_ORDER(i)     SPI_RD_ORDER(i)
#define WR_ORDER(i)     SPI_WR_ORDER(i)
#define READY(i)        SPI_READY(i)
#define CLK_DIV(i)      SPI_CLK_DIV(i)
#define RD_MODE(i)      SPI_RD_MODE(i)
#define SFSIZE(i)       SPI_SFSIZE(i)
#define TCS(i)          SPI_TCS(i)
#define RD_OPT(i)       SPI_RD_OPT(i)
#define printf dprintf

unsigned int get_ctimestamp( void );
//void check_spi_clk_div(void);
extern int check_dram_freq_reg(void) ;
//end of SST's SPI

//JSW add
void sst_spi_flw_image(unsigned int cnt,unsigned int flash_addr_offset ,unsigned int *image_addr, unsigned int image_size)
{
   unsigned int temp,temp1,temp2,temp3,temp4;
   unsigned int DRAM_temp,FLASH_temp,spi_data;
   unsigned int i, j, k; //JSW: sector(64KB) , j=page(256B) ,k=byte(4B )
   unsigned char *cur_addr;
   unsigned int cur_size;
   int shift_cnt8=0,byte_cnt=0; //must be int
   unsigned short sector_start_cnt,sector_end_cnt;
    	 
   cur_addr = image_addr;
   cur_size = image_size;

   //Calculate Erase Sector cnt
   sector_start_cnt=(flash_addr_offset/65536); 
   sector_end_cnt=sector_start_cnt+(image_size/65536);
 
  prom_printf("\nSector_start_cnt=0x%x\n",sector_start_cnt);
   prom_printf("Sector_end_cnt=0x%x\n",sector_end_cnt);

 
 /* Erase Sector loop*/
   for (i =sector_start_cnt; i <= sector_end_cnt; i++)
   {
     // printf("==============(i= %d)\n", i);
      //unsigned int spi_data;

      spi_pio_init();
      spi_sector_erase(cnt, i);
   }//end of for-i

    for(i=0;i<=image_size;i+=4)	
    {
    
   	// printf(" cur_addr=%x\n", cur_addr);
  	// printf("cur_size=%x\n", cur_size);
  	 temp = (*(cur_addr)) << 24 | (*(cur_addr + 1)) << 16 | (*(cur_addr + 2)) << 8 | (*(cur_addr + 3));
  	 //printf(" temp=%x\n",  temp);	
  	
  	 for(shift_cnt8=24;shift_cnt8>=0;shift_cnt8-=8)
  	 {
		   /* RDSR Command */
     		 spi_ready();
    		  *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
    		  *(volatile unsigned int *) SFDR = 0x05 << 24;


    		  while (1)
    		  {
    		     /* RDSR Command */
     		  	if ( ((*(volatile unsigned int *) SFDR) & 0x01000000) == 0x00000000)
    		     	{
    		       	 break;
    		     	}
  		   }
  	     
   		 //   printf(" shift_cnt8=%d\n", shift_cnt8);	
   		temp1=(temp>>shift_cnt8)&0xff;
		temp2=byte_cnt+flash_addr_offset;
		//Write 1 byte each time
   		sst_spi_write(cnt,temp2,temp1);
		byte_cnt++;
			
  	 }	//end of shift_cnt

	cur_addr+=4;
   	cur_size-=4;

	if (cur_size==0)
		break;	  
    }//end of data-burning
   

    //Data-Comparing between RAM and Flash   
   #if 0
   for(j=0;j<=image_size;j+=4)
   {
	 //prom_printf("\nj=%x\n",j);
   	 //prom_printf("\nDRAM addr=%x\n",temp4);
	 //prom_printf("\nimage_addr=%x\n",image_addr);
	

	 temp3=j+flash_addr_offset+0xBD000000;
	 //prom_printf("\ntemp3=%x\n",temp3);

	 spi_pio_init();	
	 spi_read(cnt, temp3, &spi_data);
	// spi_data=READ_MEM32(temp3);//Flash

	 //prom_printf("\nj=%x\n",j);
   	 //prom_printf("\nDRAM addr=%x\n",temp4);
	 //prom_printf("\nimage_addr=%x\n",image_addr);
	
	 temp4=image_addr+(j/4);

	 //prom_printf("\nj=%x\n",j);
   	 //prom_printf("\nDRAM addr=%x\n",temp4);
	 //prom_printf("\nimage_addr=%x\n",image_addr);
	
	 DRAM_temp =READ_MEM32(temp4);//DRAM	

	//Verified burned data each 4-Byte (DRAM vs Flash)	 		
      	if ((  DRAM_temp != spi_data))
      	 {
      		  printf("\nVerify Error at 0x%08X: Now 0x%08X, Expect 0x%08X",
           	   temp3, spi_data, DRAM_temp);
	    	  halt(); //SPI flash's data isn't the same with DRAM
	  }


	#if 0  //check by eyes if you want
		while(j<=20)
		{
			printf("\nj=%d\n",j);
			printf("Verify OK!\n");
			printf("Flash Address: 0x%x, Burned SPI-data:0x%x \
					 \n",temp3, spi_data);		
			printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
					   \n",temp4, DRAM_temp);
			break;
		}
	#endif      	
		

	if (j==image_size-4) //-4 is for last offset
		break;

     }//end verified for-loop j			
	printf("\n...Burned Data Verify OK!\n\n");
    #endif //end of data comparing
}

void srand2( unsigned int seed );
//unsigned int rand2( void );
unsigned int rand2(void);
void auto_spi_memtest(unsigned long DRAM_starting_addr,unsigned int spi_clock_div_num);
//void auto_sspi_memtest( void  );//JSW:for SST SPI

/*
 * JSW :SPI Flash Info  @20080613
 */
const struct spi_flash_db   spi_flash_known[] =
{
   {0xC2, 0x20,   0}, /* MXIC */
   {0xBF, 0x25,   0}, /* SST */ 	//JSW
   {0x01, 0x02,   1}, /* Spansion <= 8MB*/
   {0x01, 0x20,   0}, /* Spansion 128Mbit(16MB)*/ //0x18(24),2^24=16MB
};



/*
 * SPI Flash Info  //3
 */
struct spi_flash_type   spi_flash_info[5];//3 


/*
 * SPI Flash APIs
 */

/*
 * This function shall be called when switching from MMIO to PIO mode
 */
void spi_pio_init(void)
{
   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(0) | READY(1);

   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);

   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(0) | READY(1);

   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);
}

unsigned short FAST_READ=0; //1:enable,0:disable ,global variable for spi_read command
#define SPI_DUMMY 0xff


void spi_read(unsigned int cnt, unsigned int address, unsigned int *data_out)
{
   /* De-Select cnt */
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1); //CS default

   /* RDSR Command */
   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1); //CS go low

   *(volatile unsigned int *) SFDR = 0x05 << 24; //RDSR instruction code

   unsigned int status=0;
  
   while (1)
   {
    

      status = *(volatile unsigned int *) SFDR;
     // printf("status=%d\n",status);	
	

      /* RDSR Command */
      if ( (status & 0x01000000) == 0x00000000)
      {
         //printf("RDSR done \n");      	 
         break;
      }
	 
	//printf("Erasing is not finish,please wait........ \n");  	
   }

   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

   /* READ Command */
   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+cnt) | READY(1); //cs low

//READ instruction code and 3-Byte address on SI
    if (!FAST_READ)
    {
   	*(volatile unsigned int *) SFDR = (0x03 << 24) | (address & 0xFFFFFF); //0x03 is normal READ(40MHZ)
    }
    else
    {
    	//printf("\nFAST READ MODE=0x0B\n");
   	*(volatile unsigned int *) SFDR = (0x0B << 24) | (address & 0xFFFFFF); //0x0B is FAST READ  (MAX:104MHZ)
   	  spi_ready();
       *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
       *(volatile unsigned int *) SFDR = (SPI_DUMMY << 24);
       *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+cnt) | READY(1);
   }

 

   /* Read Data Out */
   *data_out = *(volatile unsigned int *) SFDR; //Data out on SO

   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);
   //printf("address<%x>=%x\n",(address+0xbfc00000),*(volatile unsigned long*)data_out);


   #if 0
  unsigned int page_count=0;
  for (page_count=0;page_count<=256;page_count+=4)
  {
  	 *data_out = *(volatile unsigned int *) SFDR;
  	printf("address<%x>=%8x  ",(address<<8)+page_count,*((volatile unsigned long*)data_out+page_count));
  	//printf("*data_out=%x\n , ",*(volatile unsigned long*)data_out+page_count);
	if(page_count%12==0)
		printf("\n");
  }
  	printf("\n");
  #endif

}


void spi_write(unsigned int cnt, unsigned int address, unsigned int data_in)
{

   /* De-select cnt */
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1); //1.release CS

   /* RDSR Command */
   spi_ready();    //2.waiting release OK
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);  //3.CS low
   *(volatile unsigned int *) SFDR = 0x05 << 24;  //4.instr code

   while (1)
   {
      unsigned char status;

      status = *(volatile unsigned int *) SFDR; //5.waitng instr code is ready
      //printf("\n status=%x\n", status);
    
      if ( (status & 0x01000000) == 0x00000000)
      {
         break;
      }
   }

   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1); //1.release CS

   /* WREN Command */
   spi_ready();  //2.waiting release OK
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);  //3.CS low
   *(volatile unsigned int *) SFDR = 0x06 << 24;  //4.instr code

   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1); //1.release CS
   /* PP Command */
   spi_ready(); //2.waiting release OK
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+cnt) | READY(1); //3.CS low

   *(volatile unsigned int *) SFDR = (0x02 << 24) | (address & 0xFFFFFF);  //4.instr code
 
   *(volatile unsigned int *) SFDR = data_in;
     
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);    //5.CS low
}


//chip erase
void spi_erase_cnt(unsigned int cnt)
{


     /* De-select cnt */
 
  *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);
		 	

   /* RDSR Command */
   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(cnt+1) | READY(1); //CS low
   *(volatile unsigned int *) SFDR = 0x05 << 24;

   unsigned int status=0;
  
   while (1)
   {
     status = *(volatile unsigned int *) SFDR;
      //printf("CE status=%d\n",status);	
	

      /* RDSR Command */
      if ( (status & 0x01000000) == 0x00000000)
      {
         //printf("Erasing ....(Need a few seconds) \n");
	 // printf("(Erase is done if the value of any address in ROM is 0xffffffff )\n");
         break;
      }
      //printf("Hang in SPI_read()/Program or Erase Error loop \n");	
   }

   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);


   /* WREN Command */
   spi_ready();
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(cnt+1) | READY(1);
   *(volatile unsigned int *) SFDR = 0x06 << 24;
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

   /* BE Command */
   spi_ready();	
  
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(cnt+1) | READY(1); //CS low
   *(volatile unsigned int *) SFDR = (0xC7 << 24);   //instr. code cnt Erase
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);  //CS high

    printf("\nErasing SPI Flash #%d ...(Need a few seconds) \n",cnt+1);
}


//JSW add :Sector Erase
void spi_sector_erase(unsigned int cnt,unsigned int i)
{

   /* WREN Command */
      spi_ready();
      //*(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
      *(volatile unsigned int *) SFDR = 0x06 << 24;
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

      /* SE Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+cnt) | READY(1);
	 
    /*JSW  Note:
      *Instruction code :
      *SE(20h) for MXIC/Spansion is 64KB,for SST is 4KB
      *SE(D8h) for MXIC/SST is 64KB,for Spansion(16MB) is 256KB.
      */

	*(volatile unsigned int *) SFDR = ( 0x20 << 24) | (i * 65535);
      //*(volatile unsigned int *) SFDR = ( SE_code << 24) | (i * 65535);
      *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);

      /* RDSR Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
      *(volatile unsigned int *) SFDR = 0x05 << 24;

      while (1)
      {
         /* RDSR Command */
         if ( ((*(volatile unsigned int *) SFDR) & 0x01000000) == 0x00000000)
              break;        
      }

      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

#if 1
      printf("Erase Sector: %d\n", i);
#endif

}

void spi_ready(void)
{
   while (1)
   {
      if ( (*(volatile unsigned int *) SFCSR) & READY(1))
         break;
   }
}


void spi_probe(void)
{
   unsigned int cnt, i;
   unsigned int temp;

	   spi_pio_init();	//JSW add
  __delay(100*100); //JSW:for spi_probe OK
    for (cnt = 0; cnt < 2; cnt++)   	
   {    	
         /* Here set the default setting */
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);	

   /*
	  *(volatile unsigned int *) SFCR = LENGTH(1) | CS(3) | RD_ORDER(1) | WR_ORDER(1) | READY(1) | CLK_DIV(1);
      *(volatile unsigned int *) SFCR = LENGTH(1) | CS(1+cnt) | RD_ORDER(1) | WR_ORDER(1) | READY(1) |
CLK_DIV(1);

   */

   
	   /* One More Toggle (May not Necessary) */
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);
	/*20081002: JSW  For spi_probe OK, add spi_ready() */
	spi_ready();	
	 *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
	spi_ready();	     
	

      /* RDID Command */
      *(volatile unsigned int *) SFDR = 0x9F << 24;
      *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+cnt) | READY(1);
    
	prom_printf("\n===========(cnt=%d)===========\n",cnt);  
	prom_printf("SFCR(b8001200) =%x\n",*(volatile unsigned int *) SFCR); 
	prom_printf("SFCSR(b8001204) =%x\n",*(volatile unsigned int *) SFCSR); 
      temp = *(volatile unsigned int *) SFDR;
      prom_printf("temp =%x\n",temp);  
      prom_printf("SFDR(b8001208) =%x\n",*(volatile unsigned int *) SFDR);

      spi_flash_info[cnt].maker_id = (temp >> 24) & 0xFF;
      spi_flash_info[cnt].type_id = (temp >> 16) & 0xFF;
      spi_flash_info[cnt].capacity_id = (temp >> 8) & 0xFF;
      spi_ready();

      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);	

	
      /* Iterate Each Maker ID/Type ID Pair */
      for (i = 0; i < sizeof(spi_flash_known) / sizeof(struct spi_flash_db); i++)
      {
 		
         if ( (spi_flash_info[cnt].maker_id == spi_flash_known[i].maker_id) &&
              (spi_flash_info[cnt].type_id == spi_flash_known[i].type_id) )
         {
		prom_printf("\n=============================\n");
		prom_printf("<Probe SPI #%d >\n",cnt+1);
		prom_printf("1.Manufacture ID=0x%x\n2.Device ID=0x%x\n3.Capacity
ID=0x%x\n",spi_flash_info[cnt].maker_id,spi_flash_info[cnt].type_id,spi_flash_info[cnt].capacity_id);
			
		/*JSW : Probe SPI info. @20070914
		   1.MXIC:2M/4M/8M/16m
		   2.Spansion:0.5M/2M
		   3.SST: 0.5M/1M/2M/4M
		   4.Spansion: 16MB  //20071106
		*/
		switch( spi_flash_info[cnt].capacity_id)
		{

			case 0x8d:
				prom_printf("4.SST SPI (0.5 MByte)!\n");
				//JSW: Modify SST size_shift for convenience of calculation later
				spi_flash_info[cnt].capacity_id-=122;
				//spi_flash_info[cnt].sector_cnt = 8;		
				//spi_flash_info[cnt].device_size = (unsigned char)((signed char)spi_flash_info[cnt].capacity_id );

				//All SST product need to do this first : Free lock-area in advance
				EWSR(cnt);
				WRSR(cnt);
				//RDSR(cnt);				
				break;

			case 0x8e:
				prom_printf("4.SST SPI (1 MByte)!\n");
				//JSW: Modify SST size_shift for convenience of calculation later
				spi_flash_info[cnt].capacity_id-=122;
				//spi_flash_info[cnt].sector_cnt = 16;		
				//spi_flash_info[cnt].device_size = (unsigned char)((signed char)spi_flash_info[cnt].capacity_id );

				//All SST product need to do this first : Free lock-area in advance
				EWSR(cnt);
				WRSR(cnt);
				//	RDSR(cnt);
				break;

			case 0x41:
				prom_printf("4.SST SPI (2 MByte)!\n");
				//JSW: Modify  SST size_shift for convenience of calculation later
				spi_flash_info[cnt].capacity_id-=44;
				//spi_flash_info[cnt].sector_cnt = 32;	

				//All SST product need to do this first : Free lock-area in advance
				EWSR(cnt);
				WRSR(cnt);
				//RDSR(cnt);
				break;


			case 0x4a:
				prom_printf("4.SST SPI (4 MByte)!\n");
				//JSW: Modify SST size_shift for convenience of calculation later
				spi_flash_info[cnt].capacity_id-=52;
				//spi_flash_info[cnt].sector_cnt = 64;					
				EWSR(cnt);
				WRSR(cnt);
				//RDSR(cnt);
				break;
				
			case 0x20:
				prom_printf("4.MXIC SPI (4 MByte)!\n");
				break;
				
			case 0x18:
				if (spi_flash_info[cnt].maker_id == 0xc2)					
					prom_printf("4.MXIC SPI (16 MByte)!\n");
				if (spi_flash_info[cnt].maker_id == 0x01)	
				{
					prom_printf("4.Spansion SPI (16 MByte)!\n");
					//This's 104MHZ available SPI,RD_MODE must be enable to fast read mode					
				}
				//spi_flash_info[cnt].sector_cnt = 256;				
				break;					
				
			case 0x17:
				
				if (spi_flash_info[cnt].maker_id == 0xc2)					
					prom_printf("4.MXIC SPI (8 MByte)!\n");
				//spi_flash_info[cnt].sector_cnt = 128;						
				break;

			case 0x16:
				if (spi_flash_info[cnt].maker_id == 0xc2)
					prom_printf("4.MXIC SPI (4 MByte)!\n");
			       //spi_flash_info[cnt].sector_cnt = 64;
			       else if (spi_flash_info[cnt].maker_id == 0x01)
				   	prom_printf("4.Spansion SPI (8 MByte)!\n");
				break;

			case 0x15:
				if (spi_flash_info[cnt].maker_id == 0xc2)					
					prom_printf("4.MXIC SPI (2 MByte)!\n");
				//spi_flash_info[cnt].sector_cnt = 32;
				break;

			case 0x14:
				if (spi_flash_info[cnt].maker_id == 0xc2)
					prom_printf("4.MXIC SPI (1 MByte)!\n");
				//spi_flash_info[cnt].sector_cnt = 16;
				else
					prom_printf("4.Spansion SPI (2 MByte)!\n");
				//spi_flash_info[cnt].sector_cnt = 32;
				break;

			case 0x13:
				prom_printf("4.Spansion SPI (1 MByte)!\n");
				//spi_flash_info[cnt].sector_cnt = 16;
				break;

			case 0x12:
				prom_printf("4.Spansion SPI (0.5 MByte)!\n");
				//spi_flash_info[cnt].sector_cnt = 8;
				break;

			default :
				prom_printf("4.Unknow type/size!\n");
				break;
		}

	spi_flash_info[cnt].device_size = (unsigned char)((signed char)spi_flash_info[cnt].capacity_id +
spi_flash_known[i].size_shift);
       //prom_printf("5.Device_ID=0x%x (2^n )\n",spi_flash_info[cnt].device_size);
      // prom_printf("5.cnt=%d\n",cnt);
	//prom_printf("5.spi_flash_info[cnt].sector_cnt=%x\n",spi_flash_info[cnt].device_size);


	
	spi_flash_info[cnt].sector_cnt =( 1 << (spi_flash_info[cnt].device_size- 16));
	prom_printf("5.Total sector-counts = %d\n",spi_flash_info[cnt].sector_cnt );
	prom_printf("6.spi_flash_info[cnt].device_size = %d\n",spi_flash_info[cnt].device_size );

	
		
          }
       }   
    
    }

    /*JSW 20070720 :
      	 Must set 1st SPI size to SFCR , but 2nd SPI is unnecessary.
      	 *If total size of SPI is over 16MB,then remember 1st SPI must be the bigger size one.
     */ 		

	/*Set SPI Parameter
	   SPI_CLK_DIV(0)= DRAM/(2)
	   SPI_CLK_DIV(7)= DRAM/(16) default setting for booting out
	
	*/
	WRITE_MEM32(SFCR, SPI_SFSIZE(spi_flash_info[0].device_size - 17) \
					| SPI_RD_ORDER(1) | SPI_WR_ORDER(1) | SPI_CLK_DIV(7) \
					//| SPI_RD_ORDER(1) | SPI_WR_ORDER(1) |  \  //JSW:use default/last SPI clock
					| SPI_TCS(15) | SPI_RD_MODE(1) | SPI_RD_OPT(0) );
	prom_printf("\n=============================\n");
	prom_printf("Set SFCR paramemer\n");
	prom_printf("1.SFCR(0xb8001200) =%x\n",*(volatile unsigned int *) SFCR);
	

	//printf("\nBefore AND, HW_STRAP_REG(0xb8000008)=%x\n",READ_MEM32(HW_STRAP_REG));	
	//prom_printf("111.SFCR(0xb8001200) =%x\n",*(volatile unsigned int *) SFCR);

	unsigned int SFCR_size=*(volatile unsigned int *) SFCR;
	unsigned int  SFSIZE_25_23;
	
	#ifdef DBG
		//prom_printf("\nSFCR_size =%x\n",SFCR_size);
	#endif

	SFSIZE_25_23=((0x03800000) & (SFCR_size));

	#ifdef DBG
		//prom_printf("\nSFSIZE_25_23 =%x\n\n",SFSIZE_25_23);
	#endif
	
	#if 1
   	switch (SFSIZE_25_23)
      	{
      		/*JSW :SFCR setting reference table
		SFCR(0xb8001200)=0xfc780000=128KB
		SFCR(0xb8001200)=0xfcf80000=256KB
		SFCR(0xb8001200)=0xfd780000=512KB
		SFCR(0xb8001200)=0xfdf80000=1MB
		SFCR(0xb8001200)=0xfe780000=2MB
		SFCR(0xb8001200)=0xfef80000=4MB
		SFCR(0xb8001200)=0xff780000=8MB
		SFCR(0xb8001200)=0xfff80000=16MB
		*/
		case 0x0:
			prom_printf("2.Set SFCR = 128 KByte!(Just for 1st SPI)\n\n"); 			
			break;

		case 0x00800000:
			prom_printf("2.Set SFCR = 256 KByte!(Just for 1st SPI)\n\n"); 			
			break;

		case 0x01000000:
			prom_printf("2.Set SFCR = 0.5 MByte!(Just for 1st SPI)\n\n"); 			
			break;

		case 0x01800000:
			prom_printf("2.Set SFCR = 1 MByte!(Just for 1st SPI)\n\n"); 			
			break;

		case 0x02000000:
			prom_printf("2.Set SFCR = 2 MByte!(Just for 1st SPI)\n\n"); 			
			break;

		case 0x02800000:
			prom_printf("2.Set SFCR = 4 MByte!(Just for 1st SPI)\n\n"); 			
			break;

		case 0x03000000:
			prom_printf("2.Set SFCR = 8 MByte!(Just for 1st SPI)\n\n"); 			
			break;

		case 0x03800000:
			prom_printf("2.Set SFCR = 16 MByte!(Just for 1st SPI)\n\n"); 			
			break;		

		default :
			prom_printf("2.Unknow size,can't set SFCR!\n\n");
			break;

	}
	#endif
	prom_printf("=============================\n"); 		
	
}

void spi_burn_image(unsigned int chip, unsigned char *image_addr, unsigned int image_size)
{

  #if 0 // 1 for SST
   unsigned int temp;
   unsigned short  i, j, k;
   unsigned char *cur_addr;
   unsigned int cur_size;
   unsigned int spi_data;
  
   cur_addr = image_addr;
   cur_size = image_size;

   printf("\nimage_size=0x%08X\n", image_size);

   /* Iterate Each Sector */
   //for (i = 0; i <= ((image_size/65535)-1); i++)
    for (i = 0; i <= (image_size/65535); i++)
   {
    
     spi_pio_init();
     spi_sector_erase(chip, i);
    }


    for (i = 0; i <= (image_size/65535); i++)
   {
      /* Iterate Each Page */
      for (j = 0; j < 256; j++)
      {
         if (cur_size == 0)
            break;

         /* WREN Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = 0x06 << 24;
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

         /* PP Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = (0x02 << 24) | (i * 65535) | (j * 256);

         for (k = 0; k < 64; k++)
         {
            temp = (*(cur_addr)) << 24 | (*(cur_addr + 1)) << 16 | (*(cur_addr + 2)) << 8 | (*(cur_addr + 3));

            spi_ready();
            if (cur_size >= 4)
            {
               *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
               cur_size -= 4;
            }
            else
            {
               *(volatile unsigned int *) SFCSR = LENGTH(cur_size-1) | CS(1+chip) | READY(1);
               cur_size = 0;
            }

            *(volatile unsigned int *) SFDR = temp;

            cur_addr += 4;

            if (cur_size == 0)
               break;
         }

         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);

         /* RDSR Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = 0x05 << 24;

         int cnt = 0;
         while (1)
         {
            unsigned int status = *(volatile unsigned int *) SFDR;

            /* RDSR Command */
            if ((status & 0x01000000) == 0x00000000)
            {
                break;
            }

            if (cnt > 2000)
            {
               printf("\nBusy Loop for RSDR: %d, Address at 0x%08X\n", status, i*65535+j*256);
busy:
               goto busy;
            }
            cnt++;
         }
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

	  //printf("\nData-Comparing between RAM and Flash .....\n");
         /* Verify Burned Image */
         /* READ Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = (0x03 << 24) | (i * 65535) | (j * 256);
	
         for (k = 0; k < 64; k++)
         {
              if (cur_size == 0)
               break;
            unsigned int data;

            temp = (*(cur_addr -256 + (k<<2) )) << 24 | (*(cur_addr -256 + (k<<2) + 1)) << 16 | (*(cur_addr - 256 + (k<<2) +
2)) << 8 | (*(cur_addr - 256 + (k<<2) + 3));
            spi_pio_init();//JSW add		
	     spi_ready();	//JSW add	
            data = *(volatile unsigned int *) SFDR;
//verify loop
#if 0
            if ((data != temp))
            {
               printf("\nVerify Error at 0x%08X: Now 0x%08X, Expect 0x%08X",
                      i*65535+j*256+(k<<2), data, temp);
halt_here:
               goto halt_here;
            }
#endif //end of verify loop
         }


         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);
      }

      if (cur_size == 0)
         break;
   } /* Iterate Each Sector */
	//printf("\nData Verify OK!\n\n");

#else //else if 2 JSW for MXIC and Spansion
   unsigned int temp;
   unsigned int i, j, k;
   unsigned char *cur_addr;
   unsigned int cur_size;
   unsigned int cnt;

   cur_addr = image_addr;
   cur_size = image_size;

   printf("\nSingle Sector : 64KB \n");
   /* Iterate Each Sector */
   for (i = 0; i < spi_flash_info[chip].sector_cnt; i++)
   {
      unsigned int spi_data;

      printf("\nspi_flash_info[chip].sector_cnt=%d\n",spi_flash_info[chip].sector_cnt);
      printf("\ni=%d\n",i);

	//__delay(1000*1000); //Erasing SPI Flash need a few times,especially MXIC
      spi_sector_erase(chip, i);
    

#if 0	
      /* WREN Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);

      *(volatile unsigned int *) SFDR = 0x06 << 24;
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

      /* SE Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
      *(volatile unsigned int *) SFDR = (0xD8 << 24) | (i * 65536);
      *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);

      /* RDSR Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
      *(volatile unsigned int *) SFDR = 0x05 << 24;

      while (1)
      {
         /* RDSR Command */
         if ( ((*(volatile unsigned int *) SFDR) & 0x01000000) == 0x00000000)
         {
            break;
         }
      }

      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

	
      printf("Erase Sector: %d\n", i);
#endif //end of sector erase

      /* Iterate Each Page */
      for (j = 0; j < 256; j++)
      {
         if (cur_size == 0)
            break;

         /* WREN Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = 0x06 << 24;
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

         /* PP Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = (0x02 << 24) | (i * 65536) | (j * 256);

         for (k = 0; k < 64; k++)
         {
            temp = (*(cur_addr)) << 24 | (*(cur_addr + 1)) << 16 | (*(cur_addr + 2)) << 8 | (*(cur_addr + 3));

            spi_ready();
            if (cur_size >= 4)
            {
               *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
               cur_size -= 4;
            }
            else
            {
               *(volatile unsigned int *) SFCSR = LENGTH(cur_size-1) | CS(1+chip) | READY(1);
               cur_size = 0;
            }

            *(volatile unsigned int *) SFDR = temp;

            cur_addr += 4;

            if (cur_size == 0)
               break;
         }

         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);

         /* RDSR Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = 0x05 << 24;

         cnt = 0;
         while (1)
         {
            unsigned int status = *(volatile unsigned int *) SFDR;

            /* RDSR Command */
            if ((status & 0x01000000) == 0x00000000)
            {
                break;
            }

      
         }

         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

	
         /*JSW:  Verify Burned Image */
	 //Command it for better performance      
		
	
	    /* READ Command */
	   /*
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = (0x03 << 24) | (i * 65536) | (j * 256);

         for (k = 0; k < 64; k++)
         {
            unsigned int data;

		if (cur_size == 0)
               break;

            temp = (*(cur_addr -256 + (k<<2) )) << 24 | (*(cur_addr -256 + (k<<2) + 1)) << 16 | (*(cur_addr - 256 + (k<<2) +
2)) << 8 | (*(cur_addr - 256 + (k<<2) + 3));

            data = *(volatile unsigned int *) SFDR;

            if ((data != temp))
            {
               printf("\nVerify Error at 0x%08X: Now 0x%08X, Expect 0x%08X",
                      i*65536+j*256+(k<<2), data, temp);
halt_here:
               goto halt_here;
            }
         }*/

         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);
      }

      if (cur_size == 0)
         break;
   } /* Iterate Each Sector */
#endif
}


//#ifdef SUPPORT_SST_SPI

void EWSR(unsigned short cnt)
{
	  //printf("\nEWSR\n ");

	 spi_ready();
	*(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
	//	Send_Byte(0x50);		/* enable writing to the status register */
      *(volatile unsigned int *) SFDR = 0x50 << 24; //swap

	//	CE_High();			/* disable device */
	  *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

}

   /* SST WRSR */
 void WRSR(unsigned short cnt)
{
	 //printf("\nWRSR\n");
	 spi_ready();
	         
	 // CE_Low();			/* enable device */
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
	 	

	//Send_Byte(0x01);		/* select write to status register */
      *(volatile unsigned int *) SFDR = (0x01 << 24);

	//Send_Byte(byte);		/* data that will change the status of BPx  or BPL (only bits 2,3,4,5,7 can be written) */
      *(volatile unsigned int *) SFDR = (0x0<<24);  //swap ,still 0

	//CE_High();			/* disable the device */
	*(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

}

 void RDSR(unsigned short cnt)
{
        //printf("\nRDSR\n ");
	unsigned char byte ;
	  spi_ready();
	
// CE_Low();			/* enable device */
	*(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);

//Send_Byte(0x05);		/* select write to status register */
      *(volatile unsigned int *) SFDR = (0x05 << 24);

 while (1)
      {
         /* RDSR Command */
         if ( ((*(volatile unsigned int *) SFDR) & 0x01000000) == 0x00000000)
         {
            break;
         }
      }

	byte = *(volatile unsigned int *) SFDR;
	printf("\nSTATUS(char)=%x\n", byte);


//CE_High();			/* disable the device */
*(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

}

void sst_spi_write(unsigned int cnt, unsigned int address, unsigned char data_in)
{
    //printf("*SST data_in=%x\n ",data_in); 	

	 /* De-select cnt */
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1); //1.release CS

   /* RDSR Command */
   spi_ready();    //2.waiting release OK
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);  //3.CS low
   *(volatile unsigned int *) SFDR = 0x05 << 24;  //4.instr code

   while (1)
   {
      unsigned char status;

      status = *(volatile unsigned int *) SFDR; //5.waitng instr code is ready
      //printf("\n status=%x\n", status);
    
      if ( (status & 0x01000000) == 0x00000000)     
      {
         break;
      }
   }

   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1); //1.release CS

   /* WREN Command */
   spi_ready();  //2.waiting release OK
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);  //3.CS low
   *(volatile unsigned int *) SFDR = 0x06 << 24;  //4.instr code
   *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1); //1.release CS

   /* BP Command */
   spi_ready(); //2.waiting release OK
   *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+cnt) | READY(1); //3.CS low

      *(volatile unsigned int *) SFDR = (0x02 << 24) | (address & 0xFFFFFF);  //4.instr code
  //  *(volatile unsigned int *) SFDR = (0x02<<24 ) ;  //4.instr code

 //JSW: for SST BP,be aware of LENGTH @2007/9/26
    *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1); //3.CS low
    *(volatile unsigned int *) SFDR = (data_in<<24);
    *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);    //5.CS HIGH
	  
   }

void sst_spi_burn_image(unsigned int cnt, unsigned char *image_addr, unsigned int image_size)
{
   unsigned int temp,temp1;
   unsigned int DRAM_temp,FLASH_temp,spi_data;
   unsigned int i, j, k;
   unsigned char *cur_addr;
   unsigned int cur_size;
   int shift_cnt8=0,byte_cnt=0; //must be int

  printf("\nimage_size=0x%08X\n", image_size);
    
   cur_addr = image_addr;
   cur_size = image_size;
   //printf("DRAM_image_addr=%x\n", image_addr);	

 /* Iterate Each Sector */
    for (i = 0; i <= (image_size/65535); i++)
   // for (i = 0; i <= ((image_size/65535)-1); i++)
    {
  	   spi_pio_init();
  	   spi_sector_erase(cnt, i);
     }//end of for-i

    for(i=0;i<=image_size;i+=4)	
    {
    
     	 temp = (*(cur_addr)) << 24 | (*(cur_addr + 1)) << 16 | (*(cur_addr + 2)) << 8 | (*(cur_addr + 3));
  	 //printf(" temp=%x\n",  temp);	
  	 for(shift_cnt8=24;shift_cnt8>=0;shift_cnt8-=8)
  	 {
  	 	 spi_pio_init();
		   /* RDSR Command */
     		 spi_ready();
    		  *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+cnt) | READY(1);
    		  *(volatile unsigned int *) SFDR = 0x05 << 24;

    		  while (1)
    		  {
    		     /* RDSR Command */
     		  	if ( ((*(volatile unsigned int *) SFDR) & 0x01000000) == 0x00000000)
    		     	{
    		       	 break;
    		     	}
  		   }
			 
   		temp1=(temp>>shift_cnt8)&0xff;
   		sst_spi_write(cnt,byte_cnt,temp1);
		byte_cnt++;
			
  	 }	//end of shift_cnt

	cur_addr+=4;
   	cur_size-=4;

	if (cur_size<=0)
		break;	
  
    }//end of data-burning

    //Data-Comparing between RAM and Flash ,need to release SPI before this
   

   for(j=0;j<=image_size;j+=4)
   {

        spi_pio_init();	//JSW add
	 spi_ready();	//JSW add
	
	 spi_read(cnt, j, &spi_data);
	 DRAM_temp =READ_MEM32(image_addr+j);//DRAM

	//Verified burned data each 4-Byte (DRAM vs Flash)	
#if 1
      	if ((  DRAM_temp != spi_data))
      	 {
      		  printf("\nVerify Error at 0x%08X: Now 0x%08X, Expect 0x%08X",
           	  0xbd000000+j, spi_data, DRAM_temp);
	    	  halt(); //SPI flash's data isn't in line with DRAM
	  }
#endif


	#if 0  //check by eyes if you want
		while(j<20)
		{
			printf("\nj=%d\n",j);
			printf("Verify OK!\n");
			printf("Flash Address: 0x%x, Burned SPI-data:0x%x \
					 \n",0xbd000000+j, spi_data);		
			printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
					   \n",image_addr+j, DRAM_temp);
			break;
		}
	#endif      	
		

	if (j==image_size-4) //-4 is for last offset
		break;

     }//end verified for-loop j
			
	//printf("\nData Verify OK!\n\n");

}


//#endif
//end of SUPPORT_SST_SPI

//JSW 20070827 auto-test-porgram for SPI and SDRAM

#define MIN(i, j)                ((i) < (j) ? (i) : (j))
#define MAX(i, j)                ((i) > (j) ? (i) : (j))

void halt()
{
halt_loop:
   return 0;
   goto halt_loop;
}

//void auto_memtest(unsigned char *start,unsigned char *end)

#ifdef DBG
void auto_spi_memtest(unsigned long DRAM_starting_addr,unsigned int spi_clock_div_num)
{
	unsigned int i, j;
	unsigned int spi_data,rseed_timer;

	WRITE_MEM32(SFCR, SPI_SFSIZE(spi_flash_info[0].device_size - 17) \
					| SPI_RD_ORDER(1) | SPI_WR_ORDER(1) | SPI_CLK_DIV(spi_clock_div_num) \
					//| SPI_RD_ORDER(1) | SPI_WR_ORDER(1) |  \  //JSW:use default/last SPI clock
					| SPI_TCS(15) | SPI_RD_MODE(1) | SPI_RD_OPT(0) );

	//check_spi_clk_div();
	
	printf("\n====> SPI #1 Device Size (KB): %d\n", 1 << (spi_flash_info[0].device_size - 10));

	//srand2(get_ctimestamp());
	rseed_timer=get_ctimestamp();
	printf("rseed_timer=0x%x\n",rseed_timer);
	srand2(rseed_timer);

	

	   /*JSW :SFCR setting reference table
		SFCR(0xb8001200)=0xfc780000=128KB
		SFCR(0xb8001200)=0xfcf80000=256KB
		SFCR(0xb8001200)=0xfd780000=512KB
		SFCR(0xb8001200)=0xfdf80000=1MB
		SFCR(0xb8001200)=0xfe780000=2MB
		SFCR(0xb8001200)=0xfef80000=4MB
		SFCR(0xb8001200)=0xff780000=8MB
		SFCR(0xb8001200)=0xfff80000=16MB
	   */

	// Set SDRAM
	for (i = 0; i < (1 << spi_flash_info[0].device_size); i += 4)
	{
		if ((i + 4) % 0x10000 == 4)
		{
			printf("==> DRAM 0x%08X\n", DRAM_starting_addr   + i);
		}

		WRITE_MEM32(DRAM_starting_addr   + i, rand2());
		//JSW:Write the flash-size's(ex:2MB) random data into DRAM
				
	}

	/*
	   for (i = 0; i < spi_flash_info[0].sector_cnt; i++)
	   {
	       spi_pio_init();
		spi_sector_erase(0,i);	
	   }
	
	*/
	
	/*  JSW Note:
	  *  MXIC/Spansion and SST have different instruction-code of verification
	  *  So you have to mask/unmask either (MXIC/Spansion) or (SST) for 1st/2nd SPI
	  *  BTW,you shall change DRAM's offset (like DRAM_starting_addr) for coverage test
	  */

	//==========================================
	//1st SPI flash
	//===========================================	
	// "1" for MXIC or Spansion , 0 for SST
	printf("\n1. Erase chip-1 and Burn Code\n");
	printf("\nSpi_flash_info[0].device_size=%d\n",spi_flash_info[0].device_size);
		 spi_pio_init(); //Must have before burn data
	#if 1
		spi_flw_image(0,0 ,(unsigned char *)DRAM_starting_addr , (1 << spi_flash_info[0].device_size));
		//spi_burn_image(0, (unsigned char *)DRAM_starting_addr  , (1 << spi_flash_info[0].device_size));
	#else
		sst_spi_burn_image(0, (unsigned char *)DRAM_starting_addr  , (1 << spi_flash_info[0].device_size));
	#endif

	
	//printf("After WRITE_MEM32....\n");
	
	
	printf("\n2. Code Verification by Programmed I/O\n\n");
	spi_pio_init();
	for (i = 0; i < (1 << spi_flash_info[0].device_size); i += 4)
	{
		spi_read(0, i, &spi_data);
	
	
		if (READ_MEM32(DRAM_starting_addr + i) != spi_data)
		{
			//printf("Verify Failed! Address: 0x%08X, Data: 0x%08X\n", i, spi_data);
			printf("Verify Fail! Flash Address: 0x%x, Burned SPI-data:0x%x \
				 \n",0xbd000000+i, spi_data);		
			printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
				   \n",(DRAM_starting_addr +i),READ_MEM32(DRAM_starting_addr   + i));
			halt();
		}

		//JSW:Check by eyes if you want
		#if 0
		while(i<20)
		{
			printf("i=%d\n",i);
			printf("Verify OK! Flash Address: 0x%x, Burned SPI-data:0x%x \
				 \n",0xbd000000+i, spi_data);		
			printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
				   \n",(DRAM_starting_addr  +i),READ_MEM32(DRAM_starting_addr   + i));
			break;
		}
		#endif
	}

	

	printf("\n3. Code Verification by Memory Mapped I/O\n\n");

	for (i = 0; i < (1 << spi_flash_info[0].device_size); i += 4)
	{
		unsigned int dram_addr = (DRAM_starting_addr   + i);
		unsigned int spi_addr = 0xBD000000 + i;

		for (j = 0; j < 4; j++)
		{
			// 32 Bit Access
			if (j == 0)
			{

			//JSW:Check by eyes if you want
			#if 0
			while(i<=20)
			{
				printf("32 Bit Access, i=%d,j=%d\n\n",i,j);
				printf("Verify OK! SPI_addr: 0x%x, Burned SPI-data:0x%x \
						 \n\n",0xbd000000+i, READ_MEM32(spi_addr+j));		
				printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
						   \n\n",DRAM_starting_addr  +i,READ_MEM32(dram_addr +j));
				break;
			}
			#endif

			   if (READ_MEM32(dram_addr) != READ_MEM32(spi_addr))
				{
					printf("32-bit Verify Failed! Address: 0x%08X, Data: 0x%08X, Expected 0x%08X\n",
							 spi_addr, READ_MEM32(spi_addr), READ_MEM32(dram_addr));
					halt();
				}
			}

			// 16 Bit Access
			if ((j == 0) || (j == 2))
			{
				#if 0//JSW:Check by eyes if you want
				while(i<=20)
				{
					printf("16 Bit Access, i=%d,j=%d\n\n",i,j);
					printf("Verify OK! SPI_addr: 0x%x, Burned SPI-data:0x%x \
						 \n\n",0xbd000000+i, READ_MEM16(spi_addr+j));		
					printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
						   \n\n",DRAM_starting_addr  +i,READ_MEM16(dram_addr +j));
					break;
				}
				#endif

				if (READ_MEM16(dram_addr + j) != READ_MEM16(spi_addr + j))
				{
					printf("16-bit Verify Failed! Address: 0x%08X, Data: 0x%08X, Expected 0x%08X\n",
							 spi_addr, READ_MEM32(spi_addr), READ_MEM32(dram_addr));
					halt();
				}
			  }

			// 8 Bit Access
			if ((j == 0) || (j == 1)|| (j == 2)|| (j == 3))
			{

				#if 0 //JSW:Check by eyes if you want		
				while(i<=20)
				{
					printf("8 Bit Access, i=%d,j=%d\n\n",i,j);
					printf("Verify OK! SPI_addr: 0x%x, Burned SPI-data:0x%x \
							 \n\n",0xbd000000+i, READ_MEM8(spi_addr+j));		
					printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
							   \n\n",DRAM_starting_addr  +i,READ_MEM8(dram_addr + j));
					break;
				}
				#endif

				if (READ_MEM8(dram_addr + j) != READ_MEM8(spi_addr + j))
				{
		
					printf("8-bit Verify Failed! Address: 0x%08X, Data: 0x%08X, Expected 0x%08X\n",
					spi_addr, READ_MEM32(spi_addr), READ_MEM32(dram_addr));
				halt();
				}
			  }//end if j==0/1/2/3
		}//end
	}


	/*SPI #2 Auto Test*/

	/*
	printf("====> SPI #2 Device Size (KB): %d\n", 1 << (spi_flash_info[1].device_size - 10));

	// Set DRAM
	for (i = 0; i < (1 << spi_flash_info[1].device_size); i += 4)
	{
		if ((i + 4) % 0x10000 == 4)
		{
			printf("==> DRAM 0x%08X\n", DRAM_starting_addr   + i);
		}

		WRITE_MEM32(DRAM_starting_addr   + i, rand2());
	}


	printf("\n1. Erase Whole chip-2 and Burn Code\n");

	//spi_pio_init();
	//spi_erase_cnt(1);	
	spi_pio_init();	

	//==========================================
	//2nd SPI flash
	//===========================================
	// "1" for MXIC or Spansion , 0 for SST	
	#if 1	
	//spi_burn_image(1, (unsigned char *)DRAM_starting_addr  , (1 << spi_flash_info[1].device_size));
	spi_flw_image(1,0 ,(unsigned char *)DRAM_starting_addr , (1 << spi_flash_info[1].device_size));
	
	#else	
	sst_spi_burn_image(1, (unsigned char *)DRAM_starting_addr  , (1 << spi_flash_info[1].device_size));	
	//Burning DRAM's data into flash
	#endif


	printf("2. Code Verification by Programmed I/O\n");
	spi_pio_init();
	for (i = 0; i < (1 << spi_flash_info[1].device_size); i += 4)
	{
		spi_pio_init();
		spi_read(1, i, &spi_data);
		
		if (READ_MEM32(DRAM_starting_addr   + i) != spi_data) //JSW:Comparing DRAM's data to flash
		{


				//printf("Verify Failed! Address: 0x%08X, Data: 0x%08X\n", i, spi_data);
			printf("Verify Fail! Flash Address: 0x%x, Burned SPI-data:0x%x \
				 \n",(0xbd000000+i+ (1 << spi_flash_info[0].device_size)), spi_data);		
			printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
				   \n",DRAM_starting_addr  +i,READ_MEM32(DRAM_starting_addr   + i));

			//JSW:Check by eyes if you want
			#if 1
			while(i<=20)
			{
				printf("i=%d\n",i);
				printf("Verify OK! Flash Address: 0x%x, Burned SPI-data:0x%x \
				 \n",(0xbd000000+i+ (1 << spi_flash_info[0].device_size)), spi_data);		
				printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
					   \n",DRAM_starting_addr  +i,READ_MEM32(DRAM_starting_addr   + i));
				break;
			}
			#endif
			
			halt();
		}
	}

	printf("3. Code Verification by Memory Mapped I/O\n");
	printf("From 0x%08X ~ 0x%08X\n",
			 0xBD000000 + (1 << spi_flash_info[0].device_size),
			 0xBD000000 + (1 << spi_flash_info[0].device_size) \
			 + MIN((1 << spi_flash_info[1].device_size), (1 << spi_flash_info[0].device_size)) - 1);

	for (i = 0; i < MIN((1 << spi_flash_info[1].device_size), (1 << spi_flash_info[0].device_size)); i += 4)
	{
		unsigned int dram_addr = DRAM_starting_addr   + i;
		unsigned int spi_addr = 0xBD000000 + (1 << spi_flash_info[0].device_size) + i;

		for (j = 0; j < 4; j++)
		{
			// 32 Bit Access
			if (j == 0)
			{

			//JSW:Check by eyes if you want
			#if 1
			while(i<=20)
			{
				printf("32 Bit Access, i=%d,j=%d\n\n",i,j);
				printf("Verify OK! SPI_addr: 0x%x, Burned SPI-data:0x%x \
						 \n\n",(0xbd000000+i+ (1 << spi_flash_info[0].device_size)), READ_MEM32(spi_addr+j));		
				printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
						   \n\n",DRAM_starting_addr  +i,READ_MEM32(dram_addr +j));
				break;
			}
			#endif
			
			if (READ_MEM32(dram_addr) != READ_MEM32(spi_addr))
				{
					printf("32-bit Verify Failed! Address: 0x%08X, Data: 0x%08X, Expected 0x%08X\n",
							 spi_addr, READ_MEM32(spi_addr), READ_MEM32(dram_addr));
					halt();
				}
			}

			// 16 Bit Access
			if ((j == 0) || (j == 2))
			{

			#if 1//JSW:Check by eyes if you want
				while(i<=20)
				{
					printf("16 Bit Access, i=%d,j=%d\n\n",i,j);
					printf("Verify OK! SPI_addr: 0x%x, Burned SPI-data:0x%x \
						 \n\n",(0xbd000000+i+ (1 << spi_flash_info[0].device_size)), READ_MEM16(spi_addr+j));		
					printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
							   \n\n",DRAM_starting_addr  +i,READ_MEM16(dram_addr +j));
					break;
				}
			#endif
			
				if (READ_MEM16(dram_addr + j) != READ_MEM16(spi_addr + j))
				{
					printf("16-bit Verify Failed! Address: 0x%08X, Data: 0x%08X, Expected 0x%08X\n",
							 spi_addr, READ_MEM32(spi_addr), READ_MEM32(dram_addr));
					halt();
				}
			}

			// 8 Bit Access
			if ((j == 0) || (j == 1)|| (j == 2)|| (j == 3))
			{
				#if 1 //JSW:Check by eyes if you want		
					while(i<=20)
					{
						printf("8 Bit Access, i=%d,j=%d\n\n",i,j);
						printf("Verify OK! SPI_addr: 0x%x, Burned SPI-data:0x%x \
							 \n\n",(0xbd000000+i+ (1 << spi_flash_info[0].device_size)), READ_MEM8(spi_addr+j));		
						printf("DRAM Address: 0x%x, Correct DRAM-data:0x%x \
							   \n\n",DRAM_starting_addr  +i,READ_MEM8(dram_addr + j));
						break;
					}
				#endif
				
				if (READ_MEM8(dram_addr + j) != READ_MEM8(spi_addr + j))
				{
			
					printf("8-bit Verify Failed! Address: 0x%08X, Data: 0x%08X, Expected 0x%08X\n",
						 spi_addr, READ_MEM32(spi_addr), READ_MEM32(dram_addr));
					halt();
				}
			}//end of j=0/1/2/3
		}
	}


   */ //End of 2nd SPI Flash test
	printf("\nSPI/DRAM verify done! \n\n");
}


//==================================
//JSW :Below 3 functions for generating SPI/DRAM random data source,just using for verification
unsigned int rtl_seed = 0xDeadC0de;

#define using_timer0_as_seed 1

unsigned int get_ctimestamp( void )
{
      unsigned int temp;
#if using_timer0_as_seed	
	temp= (READ_MEM32(0xb8003108));//TC0CNT;
	return temp;
	//return 0xe8a00;
#else
	return 0x3a9800;//if verify error,change this value as temp seed's data 
	/*error data record
	    1.(0x3c2a00)
	    2.(0x3a9800)
	*/
#endif
}


void srand2( unsigned int seed )
{
	rtl_seed = seed;
}

/*
unsigned int rand2( void )
{
	unsigned int hi32, lo32;

	hi32 = (rtl_seed>>16)*19;
	lo32 = (rtl_seed&0xffff)*19+37;
	hi32 = hi32^(hi32<<16);
	return ( rtl_seed = (hi32^lo32) );
}
*/

static unsigned int x = 123456789;


unsigned int rand2(void)
{
   static unsigned int y = 362436;
   static unsigned int z = 521288629;
   static unsigned int c = 7654321;

   unsigned long long t, a= 698769069;

   x = 69069 * x + 12345;
   y ^= (y << 13); y ^= (y >> 17); y ^= (y << 5);
   t = a * z + c; c = (t >> 32); z = t;

   return x + y + z;
}

//==================================
#endif


//void spi_flw_image(unsigned int cnt,unsigned int flash_addr_offset ,unsigned int *image_addr, unsigned int image_size)
//Gh
int spi_flw_image(unsigned int chip, unsigned int flash_addr_offset ,unsigned char *image_addr, unsigned int image_size)
{
   unsigned int temp;
   unsigned int i, j, k;
   unsigned char *cur_addr;
   unsigned int cur_size;
   unsigned int cnt;

    cur_addr = image_addr;
   cur_size = image_size;

   unsigned int sector_start_cnt=flash_addr_offset/65535;
   unsigned int sector_end_cnt=sector_start_cnt+(image_size/65535);

  // prom_printf("\nSector_start_cnt=0x%x\n",sector_start_cnt);
  // prom_printf("Sector_end_cnt=0x%x\n",sector_end_cnt);


  //check_spi_clk_div();//JSW: it will cause fail
spi_pio_init();	//JSW add
 // __delay(100*100); //JSW:for spi_probe OK
 //prom_printf("\nimage_addr=0x%x\n",image_addr);
 //prom_printf("image_size=0x%x\n",image_size);
//  prom_printf("\ncur_addr=0x%x\n",cur_addr);
//   prom_printf("cur_size=0x%x\n",cur_size);
//    prom_printf("flash_addr_offset=0x%x\n",flash_addr_offset);

   /* Iterate Each Sector */
   for (i = sector_start_cnt; i <= sector_end_cnt; i++)
   {
      unsigned int spi_data;

      /* WREN Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);

      *(volatile unsigned int *) SFDR = 0x06 << 24;
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

      /* SE Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
      *(volatile unsigned int *) SFDR = (0xD8 << 24) | (i * 65536);
      *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);

      /* RDSR Command */
      spi_ready();
      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
      *(volatile unsigned int *) SFDR = 0x05 << 24;

      while (1)
      {
         /* RDSR Command */
         if ( ((*(volatile unsigned int *) SFDR) & 0x01000000) == 0x00000000)
         {
            break;
         }
      }

      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

#if 1
      printf("Erase Sector: %d\n", i);
#endif

      /* Iterate Each Page */
      for (j = 0; j < 256; j++)
      {
         if (cur_size == 0)
            break;

	//JSW Add
	  //		
	      spi_ready();
	      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
	      *(volatile unsigned int *) SFDR = 0x05 << 24;

	      while (1)
	      {
	        
	         if ( ((*(volatile unsigned int *) SFDR) & 0x01000000) == 0x00000000)
	         {
	            break;
	         }
	      }
	      *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);
	  //
	 
         /* WREN Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = 0x06 << 24;
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

         /* PP Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = (0x02 << 24) | (i * 65536) | (j * 256);

         for (k = 0; k < 64; k++)
         {
            temp = (*(cur_addr)) << 24 | (*(cur_addr + 1)) << 16 | (*(cur_addr + 2)) << 8 | (*(cur_addr + 3));

            spi_ready();
            if (cur_size >= 4)
            {
               *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
               cur_size -= 4;
            }
            else
            {
               *(volatile unsigned int *) SFCSR = LENGTH(cur_size-1) | CS(1+chip) | READY(1);
               cur_size = 0;
            }

            *(volatile unsigned int *) SFDR = temp;

            cur_addr += 4;

            if (cur_size == 0)
               break;
         }

         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);

         /* RDSR Command */
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = 0x05 << 24;

         cnt = 0;
         while (1)
         {
            unsigned int status = *(volatile unsigned int *) SFDR;

            /* RDSR Command */
            if ((status & 0x01000000) == 0x00000000)
            {
                break;
            }

            if (cnt > (1000*1000*200))
            {
               printf("\nBusy Loop for RSDR: %d, Address at 0x%08X\n", status, i*65536+j*256);
busy:
               goto busy;
            }
            cnt++;
         }

         *(volatile unsigned int *) SFCSR = LENGTH(0) | CS(3) | READY(1);

         /* Verify Burned Image */
         /* READ Command */
/*		
         spi_ready();
         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(1+chip) | READY(1);
         *(volatile unsigned int *) SFDR = (0x03 << 24) | (i * 65536) | (j * 256);

         for (k = 0; k < 64; k++)
         {
            unsigned int data;

            temp = (*(cur_addr -256 + (k<<2) )) << 24 | (*(cur_addr -256 + (k<<2) + 1)) << 16 | (*(cur_addr - 256 + (k<<2) +
2)) << 8 | (*(cur_addr - 256 + (k<<2) + 3));

            data = *(volatile unsigned int *) SFDR;

            if ((data != temp))
            {
               printf("\nVerify Error at 0x%08X: Now 0x%08X, Expect 0x%08X",
                      i*65536+j*256+(k<<2), data, temp);
halt_here:
               goto halt_here;
            }
         }
*/
         *(volatile unsigned int *) SFCSR = LENGTH(3) | CS(3) | READY(1);
      }

      if (cur_size == 0)
         break;
   } /* Iterate Each Sector */
   return 1;
}
