/*****************************************************************************/

/*
 *	flatfs.h -- support for flat FLASH file systems.
 *
 *	(C) Copyright 1999, Greg Ungerer (gerg@snapgear.com).
 *	(C) Copyright 2000, Lineo Inc. (www.lineo.com)
 *	(C) Copyright 2001-2002, SnapGear (www.snapgear.com)
 */

/*****************************************************************************/
#ifndef flatfs_h
#define flatfs_h
/*****************************************************************************/

/*
 * Hardwire the source and destination directories :-(
 */
//#define	FILEFS		"/dev/flash/config"
#define	DEFAULTDIR	"/etc/nvram"
#define	SRCDIR		"/tmp/configs"
//#define	SRCDIR		"/tmp/mnt"
#define	DSTDIR		SRCDIR

#define FLATFSD_CONFIG	".flatfsd"

#define MTD_PATH	"/tmp/cfg_mtd"


//#define	FILEFS  MTD_PATH
#define VERSION "3.0.0"
#define SUBSYS "mtd"

extern char *FILEFS;
/*
 * Globals for file and byte count.
 */
extern int numfiles;
extern int numbytes;
extern int numdropped;
extern int numversion;

extern int flat_restorefs(void);
extern int flat_savefs(int version);
extern int flat_new(const char *dir);
extern int flat_clean(int realclean);
extern int flat_filecount(void);
extern int flat_needinit(void);
extern int flat_check(void);

#define ERROR_CODE()	(-(__LINE__)) /* unique failure codes :-) */

/*****************************************************************************/
#endif
