get_proto() #$1:0 -- tcp, 1--udp, 2--all
{
	if [ "$1" = "0" ] || [ "$1" = "TCP" ]; then
		echo -n "tcp"
	elif [ "$1" = "1" ] || [ "$1" = "UDP" ]; then
		echo -n "udp"
	else
		echo -n "*"
	fi
}

config_forwarding_add()
{
	num=$($nvram get port_forwarding_num)
	num=$(($num+1))

	$nvram set forwarding$num="$1 $2 $3 $4 $5 0"
	$nvram set forward_port$num="$3-$4>$5:$3-$4,$(get_proto $2),on"
	if [ "$6" = "1" ];then
		num=$(($num+1))
		$nvram set forwarding$num="$1 TCP 1503 1503 $5 1"
		$nvram set forward_port$num="1503-1503>$5:1503-1503,$(get_proto TCP),on"
	fi
	$nvram set port_forwarding_num=$num
	$nvram set port_forward_trigger="0"
	$nvram set forfirewall="port_forward"
}

config_forwarding_editnum()
{
	$nvram set portforward_editnum=$1
	$nvram set forfirewall="port_forward"
}

config_forwarding_edit()
{
	edit_num=$($nvram get portforward_editnum)
	total_num=$(nvram get port_forwarding_num)
	if [ $edit_num -lt $total_num ];then
		serflag_num=$(($edit_num+1))
		serflag=`$nvram get forwarding$serflag_num | awk '{print $6 }'`
		if [ "$serflag" = "0" ];then
			if [ "$6" = "0" ];then
				$nvram set forwarding$edit_num="$1 $2 $3 $4 $5 0"
				$nvram set forward_port$edit_num="$3-$4>$5:$3-$4,$(get_proto $2),on"
			else
				$nvram set forwarding$edit_num="$1 $2 $3 $4 $5 0"
				$nvram set forward_port$edit_num="$3-$4>$5:$3-$4,$(get_proto $2),on"
				config_forwarding_insert $edit_num
			fi
		else
			if [ "$6" = "1" ];then
				$nvram set forwarding$edit_num="$1 $2 $3 $4 $5 0"
				$nvram set forward_port$edit_num="$3-$4>$5:$3-$4,$(get_proto $2),on"
				$nvram set forwarding$serflag_num="$1 TCP 1503 1503 $5 1"
				$nvram set forward_port$serflag_num="1503-1503>$5:1503-1503,$(get_proto TCP),on"
			else
				$nvram set forwarding$edit_num="$1 $2 $3 $4 $5 0"
				$nvram set forward_port$edit_num="$3-$4>$5:$3-$4,$(get_proto $2),on"
				config_forwarding_del $serflag_num
			fi
		fi
	else 
		if [ "$6" = "0" ];then
				$nvram set forwarding$edit_num="$1 $2 $3 $4 $5 0"
				$nvram set forward_port$edit_num="$3-$4>$5:$3-$4,$(get_proto $2),on"
		else
				$nvram set forwarding$edit_num="$1 $2 $3 $4 $5 0"
				$nvram set forward_port$edit_num="$3-$4>$5:$3-$4,$(get_proto $2),on"
				config_forwarding_insert $edit_num
		fi
	fi
	$nvram set port_forward_trigger="0"
	$nvram set forfirewall="port_forward"
}

config_forwarding_del()
{
	num=$($nvram get port_forwarding_num)

	serflag_num=$(($1+1))
	distance=1
	$nvram unset forwarding$1
	$nvram unset forward_port$1
	serflag=`$nvram get forwarding$serflag_num | awk '{print $6 }'`
	if [ "$serflag" = "1" ];then
		$nvram unset forwarding$serflag_num
		$nvram unset forward_port$serflag_num
		distance=2
	fi
	nvram set port_forwarding_num=$(($num-$distance))

	first=$1
	second=$(($1+$distance))
	second_entry="$($nvram get forwarding${second})"
	while [ "$second_entry" != "" ]; do
		$nvram set forwarding${first}="$second_entry"
		$nvram set forward_port${first}="$($nvram get forward_port${second})"
		first=$(($first+1))
		second=$(($second+1))
		second_entry="$($nvram get forwarding${second})"
	done
	while [ $first -lt $second ]; do
		nvram unset forwarding${first}
	        nvram unset forward_port${first}
		first=$(($first+1))
	done
	
	$nvram set port_forward_trigger="0"
	$nvram set forfirewall="port_forward"
}

config_forwarding_insert()
{
	line=`$nvram get port_forwarding_num`
	total_num=$line
	num=$1
	new_num=$(($1+1))
	new_line=$(($line+1))
	while (test $line -gt $num)
	do
		nvram set forwarding${new_line}="$($nvram get forwarding${line})"
		nvram set forward_port${new_line}="$($nvram get forward_port${line})"
		new_line=${line}
		line=$(($line-1))
	done
	addname=`$nvram get forwarding$1 | awk '{print $1 }'`
	addip=`$nvram get forwarding$1 | awk '{print $5 }'`
	if [ $line -gt $num ];then
		$nvram set forwarding$new_num="$addname TCP 1503 1503 $addip 1"
		$nvram set forward_port$new_num="1503-1503>$addip:1503-1503,$(get_proto TCP),on"
	elif [ $line -eq $num ];then
		$nvram set forwarding$new_line="$addname TCP 1503 1503 $addip 1"
		$nvram set forward_port$new_line="1503-1503>$addip:1503-1503,$(get_proto TCP),on"
	fi
	total_num=$(($total_num+1))
	$nvram set port_forwarding_num=$total_num
	
}
